package org.apkplug.Bundle;

import org.osgi.framework.BundleContext;
/**
 * APKPLUG定义的通用默认的OSGI服务  
 * 大部分情况下我们可以通过它传递宿主应用中存在的数据类型例如  View Activity等
 * 目的:
 *    因为OSGI服务本身需要定义Java interface 在实际开发过程中比较繁琐，
 *    因此我们约定了一个比较通用的OSGI服务interface。
 * @author 梁前武
 * v2.0.0
 */
public interface ApkplugOSGIService {
	/**
	 * 通用接口
	 * @param context         调用服务的插件上下文
	 * @param serviceName     服务名称(由服务提供者与使用者约定)
	 * @param type            服务类型(由服务提供者与使用者约定)
	 * @param objs            传值       (由前两个参数可确定约定的传值类型)
	 * @return                (由服务提供者与使用者约定)
	 */
	Object ApkplugOSGIService(BundleContext context,String serviceName,int type,Object... objs);
}
