package org.apkplug.Bundle;

public class InstallInfo {
	/**
	 * 本地插件文件的决定路径 (apkplug2.6.4前 apk文件路径前须加"file:")
	 */
	private String apkFilePath=null;
	
	/**
	 * 插件启动级别     
	 * 小于default_startlevel的插件将在框架启动时启动  
	 * 大于等于default_startlevel的将不自动启动  
	 * default_startlevel=2
	 */
	public int startlevel=2;
	/**
	 * 安装时是否匹配版本  
	 * true 如果版本相同停止安装/更新  
	 * false 版本相同卸载后重新安装 
	 */
	public boolean isCheckVersion=true;
	/**
	 * 是否可以安装未改造未插件的APK文件即 没有添加osgi.jar plugin.xml文件的apk 【v3.0.0以上企业版才支持,普通版不支持】
	 */
	public boolean isInstallAPK=true;
	/**
	 * 插件与宿主签名是否必须一致   默认为false【可以不一致】
	 */
	public boolean Check_Main_Signature=false;
	/**
	 * 插件更新时与旧版插件签名是否必须一致   默认为false【可以不一致】
	 */
	public boolean Check_Bundle_Signature=false;
	
	/**
	 * @return apkFilePath
	 */
	public String getApkFilePath() {
		return apkFilePath;
	}
	/**
	 * @param apkFilePath 要设置的 apkFilePath
	 */
	public void setApkFilePath(String apkFilePath) {
		//apkFilePath 加上 file:
		this.apkFilePath = apkFilePath.indexOf(":")!=-1?apkFilePath:"file:"+apkFilePath;
	}
}
