package org.apkplug.Bundle;


import org.osgi.framework.Bundle;
import org.osgi.framework.BundleContext;

import android.app.Activity;
import android.content.Intent;
/**
 * Activity启动OSGI服务interface
 * @author 梁前武 
 * www.apkplug.com
 */
public interface StartActivity {
	/**
	 * 通过Intent启动Activity
	 * 须在plugin.xml文件中配置Export-Package该Activiy文件完整包路径
	 * @param context
	 * @param intent  
	 */
	public void StartActivity(BundleContext context,Intent intent);
	/**
	 * 启动指定 activityClass 的Activity
	 * 通过该接口可以实现插件隐藏Activity类的功能
	 * 避免在plugin.xml文件中配置Export-Package即可启动Activity
	 * @param context
	 * @param intent        用于传参
	 * @param activityClass
	 */
	public void StartActivity(BundleContext context, Intent intent,Class activityClass);
	/**
	 * 启动指定Bundle中的Activity
	 * 该方法可以实现多个Bundle有相同路径的Activity问题
	 * @param context
	 * @param bundle
	 * @param className
	 */
	public void StartActivity(BundleContext context, Bundle bundle,String className);
	/**
	 * 保留不使用
	 * @param context
	 * @param activityClass
	 */
	public void DestroyActivity(BundleContext context, Class activityClass);
	/**
	 * 保留不使用
	 * @param context
	 * @param activityClass
	 */
	public void AddActivity(BundleContext context, String activityName);
	/**
	 * 保留不使用
	 * @param context
	 * @param activityClass
	 */
	public void AddActivity(BundleContext context, Class activityClass);
	/**
	 * 保留不使用
	 * @param context
	 * @param activityClass
	 */
	public Intent getIntentActivity(Activity activity,BundleContext context,Intent intent);
}
