package org.apkplug.Bundle.Theme;

import org.apkplug.Bundle.OSGIServiceAgent;
import org.osgi.framework.BundleContext;
import org.osgi.framework.InvalidSyntaxException;
import org.osgi.framework.ServiceEvent;
import org.osgi.framework.ServiceListener;
import org.osgi.framework.ServiceReference;
/**
 * 主题切换相关OSGI服务代理
 * @author 梁前武
 * www.apkplug.com
 * @param <T>
 */
public class ThemeAgent{
	private  OSGIServiceAgent<ThemeControl> tca=null;
	private  OSGIServiceAgent<RegThemeChengeListener> tcl=null;
	private ApkplugTheme service=null;
	private ServiceReference ref=null;
	private BundleContext mcontext;
	/**
	 * @param context 
	 * @param serviceClass  自定义的主题样式切换接口
	 * 该类将自定监听主题包是否注册serviceClass接口
	 * 如果getService()返回为null 表示没有主题包注册serviceClass接口
	 * 如果getService()返回不为空    表示有主题包提供了serviceClass接口
	 */
	public ThemeAgent(BundleContext context){
		this.mcontext=context;
		tca=new OSGIServiceAgent<ThemeControl>(context,ThemeControl.class);
		tcl=new OSGIServiceAgent<RegThemeChengeListener>(context,RegThemeChengeListener.class);
		try {
			mcontext.addServiceListener(
					new ServiceListener(){
						@Override
						public void serviceChanged(ServiceEvent event) {
							switch  (event.getType()) {
								case  ServiceEvent.REGISTERED:
									if  (ref  ==   null ) {
										ref  =  event.getServiceReference();
										service  =  (ApkplugTheme) mcontext.getService(ref);//
									}
									break ;
								case  ServiceEvent.UNREGISTERING:
									if  (ref  ==  event.getServiceReference()) {
										mcontext.ungetService(ref);  
										service  =   null ;
											ref  =   null ;
									}
									break ;
								}
							
						}
			},String.format("(objectclass=%s)",ApkplugTheme.class.getCanonicalName()) );
		} catch (InvalidSyntaxException e) {
			e.printStackTrace();
		}
	}
	/**
	 * @param context 
	 * @param filter  过滤器
	 * 该类将自定监听主题包是否注册serviceClass接口
	 * 如果getService()返回为null 表示没有主题包注册serviceClass接口
	 * 如果getService()返回不为空    表示有主题包提供了serviceClass接口
	 public ThemeAgent(BundleContext context,String filter){
		this.mcontext=context;
		tca=new OSGIServiceAgent<ThemeControl>(context,ThemeControl.class);
		tcl=new OSGIServiceAgent<RegThemeChengeListener>(context,RegThemeChengeListener.class);
		try {
			mcontext.addServiceListener(
					new ServiceListener(){
						@Override
						public void serviceChanged(ServiceEvent event) {
							switch  (event.getType()) {
								case  ServiceEvent.REGISTERED:
									if  (ref  ==   null ) {
										ref  =  event.getServiceReference();
										service  =  (T) mcontext.getService(ref);//
									}
									break ;
								case  ServiceEvent.UNREGISTERING:
									if  (ref  ==  event.getServiceReference()) {
										mcontext.ungetService(ref);  
										service  =   null ;
											ref  =   null ;
									}
									break ;
								}
							
						}
			},filter );
		} catch (InvalidSyntaxException e) {
			e.printStackTrace();
		}
	}*/
	/**
	 * 获取主题切换服务接口
	 * @return
	 * @throws Exception
	 */
	public ThemeControl getThemeControl() throws Exception{
		return tca.getService();
	}
	/**
	 * 获取用于监听主题切换事件的注册服务
	 * @return
	 * @throws Exception
	 */
	public RegThemeChengeListener getRegThemeChengeListener() throws Exception{
		return tcl.getService();
	}
	public ApkplugTheme getService(){
		return service;
	}
}
