package org.apkplug.app;
/**
 * 框架启动所需的配置接口
 * @author 梁前武 
 * www.apkplug.com
 * v2.0.0
 */
public interface PropertyInstance {
	/**
	 * 当出现Apkplug与其他框架共用出现Service类无法找到时请将
	 * Start_Service_for_Init设置为false[延时启动Service支持] 
	 * 默认为true
	 */
	public static String Start_Service_for_Init="Start_Service_for_Init";
	/**
	 * 获取持久化的记录
	 * @param key
	 * @return
	 */
	public  String getProperty(String key);
	/**
	 * 保持持久化的记录
	 * @param key
	 * @param v
	 */
	public  void setProperty(String key,String v);
	/**
	 * 框架启动时将自动安装该该函数提供的文件
	 * @return  本地插件绝对路径
	 */
	public String[] AutoInstall();
	/**
	 * 框架启动时将自动安装并启动该该函数提供的文件
	 * @return  本地插件绝对路径
	 */
	public String[] AutoStart();
	/**
	 * 在调试模式中调用
	 * FrameworkInstance.shutdown();将清除所有已缓存的
	 * 所以你可以再上一次调试完成推出时调用shutdown清除插件缓存
	 * @return
	 */
	public boolean Debug();
}
