package org.apkplug.mxdstream.streamip;
import org.apkplug.Bundle.OSGIServiceAgent;
import org.osgi.framework.BundleContext;

public class RegStreamIPAgent {
	private static RegStreamIPAgent _instance=null;
	//单例静态工厂方法,同步防止多线程环境同时执行 
		synchronized public static RegStreamIPAgent getInstance(BundleContext mContext){
		   if(_instance==null){
			   _instance=new RegStreamIPAgent(mContext);
		   }
		   return _instance;
		}
		private OSGIServiceAgent<RegStreamIP> agent=null;
		private RegStreamIPAgent(BundleContext mContext){
			agent=new OSGIServiceAgent<RegStreamIP>(mContext,RegStreamIP.class);
		}
		
		/**
		 * 注册数据流监听 【预注册,插件安装时从plugin.xml中Stream-IP中获取的IP ,当有相应IP数据包到达是可唤醒相应插件】
		 * @param bundleid
		 * @param StreamIP
		 * @return  0 注册成功  -1 注册失败 该StreamIP已被注册
		 */
		public int registerMXDStreamCallbacks(long bundleid,String StreamIP){
			try {
				if(agent.getService()!=null){
					return agent.getService().registerMXDStreamCallbacks(bundleid, StreamIP);
				}
			} catch (Exception e) {
				// TODO 自动生成的 catch 块
				e.printStackTrace();
			}
			return -2;
		}
		/**
		 * 注册数据流监听器【插件启动时注册,以后即可获取相应IP的数据包】
		 * @param comtext
		 * @param StreamIP
		 * @param callback
		 * @return  0 注册成功  -1 注册失败 该StreamIP已被注册
		 */
		public int registerMXDStreamCallbacks(BundleContext context,String StreamIP,StreamIPRever callback){
			try {
				if(agent.getService()!=null){
					return agent.getService().registerMXDStreamCallbacks(context, StreamIP, callback);
				}
			} catch (Exception e) {
				// TODO 自动生成的 catch 块
				e.printStackTrace();
			}
			return -2;
		}
		public void unregisterMXDStreamCallbacks(BundleContext context,String StreamIP){
			try {
				if(agent.getService()!=null){
					 agent.getService().unregisterMXDStreamCallbacks(context, StreamIP);
				}
			} catch (Exception e) {
				// TODO 自动生成的 catch 块
				e.printStackTrace();
			}
		}
		public void unregisterMXDStreamCallbacks(StreamIPRever callback){
			try {
				if(agent.getService()!=null){
					 agent.getService().unregisterMXDStreamCallbacks(callback);
				}
			} catch (Exception e) {
				// TODO 自动生成的 catch 块
				e.printStackTrace();
			}
		}
}
