/**
 * @author 梁前武@点豆科技
 * www.apkplug.com
 * 2015年1月18日
 */
package org.apkplug.mxdstream.streamip;
/**
 * StreamIP 数据流接收器  
 * 在RegStreamIP注册StreamIP时要求提供这个回调接口
 * APKPLUG 2.7.0 【企业版支持StreamIP管道通信】
 */
public interface StreamIPRever {
	/**
	 * 当前的数据流通道 
	 * 当数据流通道变更时【如连接到对端TCP连接】会调用该函数发送最新的StreamIPChannel
	 * 
	 * 当StreamIPRever 注册到StreamIP中时也会传递StreamIPChannel  【可先判断一下StreamIPChannel是否为null】
	 * @param channel
	 */
	public void ChannelChanged(StreamIPChannel channel);
	/**
	 * @param manager              Channel 终端数据通道,可用来发送信息
	 * @param RemoteDeviceCode     远程设备ID
	 * @param RemoteDeviceType     远程设备类型
	 * @param RemoteIP             远程设备的StreamIP
	 * @param TargetIP             本机接收的StreamIP
	 * @param type                 备用
	 * @param data                 发送的原始数据
	 */
	public void RevStream(StreamIPChannel channel,String RemoteDeviceCode,byte RemoteDeviceType,String RemoteIP,String TargetIP,byte type,byte[] data);
	/**
	 * 终端连接成功了    【只会发送给已经启动并注册MxdStreamCallback的接收器】
	 * @param manager
	 * @param state    1 连接成功 -1 连接断开
	 */
	public void ChannelStateChanged(StreamIPChannel channel,int state);
}
