/**
 * @author 梁前武@点豆科技
 * www.apkplug.com
 * 2015年1月18日
 */
package org.apkplug.mxdstream.streamip.rever;
import org.apkplug.mxdstream.streamip.StreamIPChannel;
import org.apkplug.mxdstream.streamip.StreamIPRever;

import android.util.Log;

import com.mxdstream.utils.Observer.Subject;
import com.mxdstream.utils.util.byteTools;
import com.mxdstream.base.expStreamPipo;
import com.mxdstream.recver.SyncQueueStreamRecverRev;

/**
 * StreamIP数据接收器封装,也继承SyncQueueStreamRecverRev 作为解析器
 * 通过继承
 * APKPLUG 2.7.0 【企业版支持StreamIP管道通信】
 */
public abstract class AbStreamIPRever implements StreamIPRever{
	/**
	 * 
	 * @param tag
	 * @param myip  本接收器的默认StreamIP
	 */
	public AbStreamIPRever(String myip) {
		this.MyIP=myip;
	}
	
	private String MyIP="0.0.0.0";
	private String RemoteIP="0.0.0.0";
	//远端设备码
	private String RemoteDeviceCode="0.0.0.0";
	//远端设备类型
	private byte RemoteDeviceType=0;
	// TerminalMxdStreamRever
	@Override
	public void ChannelChanged(StreamIPChannel channel) {
		this.channel=channel;
	}

	private StreamIPChannel channel=null;
	//  handle
	
	@Override
	public void RevStream(StreamIPChannel channel,String RemoteDeviceCode,byte RemoteDeviceType,String RemoteIP,String TargetIP,byte type, byte[] data) {
		this.setRemoteIP(RemoteIP);
		this.setChannel(channel);
		this.setRemoteDeviceCode(RemoteDeviceCode);
		this.setRemoteDeviceType(RemoteDeviceType);
		//进行数据操作
		//
	}
	
	/**
	 * 发送数据到目标StreamIP
	 * @param TargetIP   目标StreamIP
	 * @param type   【备用】
	 * @param data   原始数据
	 */
	public void SendMxdStream(String TargetIP,byte type,byte[] data){
		if(channel!=null){
			channel.SendStream(this.getMyIP(), TargetIP, type, data);
		}
	}
	/**
	 * 发送数据到上次接收到数据的StreamIP
	 * @param type  【备用】
	 * @param data   原始数据
	 */
	public void SendMxdStream(byte type,byte[] data){
		if(channel!=null){
			channel.SendStream(this.getMyIP(), this.getRemoteIP(), type, data);
		}
	}
	// get set
	/**
	 * @return remoteDeviceCode 远程设备的设备码
	 */
	public String getRemoteDeviceCode() {
		return RemoteDeviceCode;
	}
	/**
	 * @param remoteDeviceCode 远程设备的设备码
	 */
	public void setRemoteDeviceCode(String remoteDeviceCode) {
		RemoteDeviceCode = remoteDeviceCode;
	}
	/**
	 * @return remoteDeviceType 远程设备的类型
	 */
	public byte getRemoteDeviceType() {
		return RemoteDeviceType;
	}
	/**
	 * @param remoteDeviceType 远程设备的类型
	 */
	public void setRemoteDeviceType(byte remoteDeviceType) {
		RemoteDeviceType = remoteDeviceType;
	}
	/**
	 * @return channel 管理器 可以用来发送数据  
	 */
	public StreamIPChannel getChannel() {
		return channel;
	}
	/**
	 * @param channel  管理器 可以用来发送数据
	 */
	public void setChannel(StreamIPChannel channel) {
		this.channel = channel;
	}
	
	/**
	 * @return 远端设备的StreamIP
	 */
	public String getRemoteIP() {
		return RemoteIP;
	}
	/**
	 * @param RemoteIP 远端设备的StreamIP
	 */
	public void setRemoteIP(String RemoteIP) {
		this.RemoteIP = RemoteIP;
	}
	/**
	 * @return myIP   本接收器的StreamIP
	 */
	public String getMyIP() {
		return MyIP;
	}
	
}
