/*
 * $Header: /cvshome/repository/org/osgi/framework/BundleContext.java,v 1.21 2002/11/14 13:49:34 pkriens Exp $
 *
 * Copyright (c) The Open Services Gateway Initiative (2000, 2002).
 * All Rights Reserved.
 *
 * Implementation of certain elements of the Open Services Gateway Initiative
 * (OSGI) Specification may be subject to third party intellectual property
 * rights, including without limitation, patent rights (such a third party may
 * or may not be a member of OSGi). OSGi is not responsible and shall not be
 * held responsible in any manner for identifying or failing to identify any or
 * all such third party intellectual property rights.
 *
 * This document and the information contained herein are provided on an "AS
 * IS" basis and OSGI DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO ANY WARRANTY THAT THE USE OF THE INFORMATION HEREIN WILL
 * NOT INFRINGE ANY RIGHTS AND ANY IMPLIED WARRANTIES OF MERCHANTABILITY OR
 * FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT WILL OSGI BE LIABLE FOR ANY
 * LOSS OF PROFITS, LOSS OF BUSINESS, LOSS OF USE OF DATA, INTERRUPTION OF
 * BUSINESS, OR FOR DIRECT, INDIRECT, SPECIAL OR EXEMPLARY, INCIDENTIAL,
 * PUNITIVE OR CONSEQUENTIAL DAMAGES OF ANY KIND IN CONNECTION WITH THIS
 * DOCUMENT OR THE INFORMATION CONTAINED HEREIN, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH LOSS OR DAMAGE.
 *
 * All Company, brand and product names may be trademarks that are the sole
 * property of their respective owners. All rights reserved.
 */

package org.osgi.framework;

import java.io.File;
import java.io.InputStream;
import java.util.Dictionary;

import android.content.Context;




public abstract interface BundleContext
{

    public abstract String getProperty(String key);

    public abstract Bundle getBundle();

    public abstract Bundle installBundle(String location)
    throws BundleException;

   
    public abstract Bundle installBundle(String location, InputStream in)
    throws BundleException;

    public abstract Bundle getBundle(long id);

    
    public abstract Bundle[] getBundles();

    
    public abstract void addServiceListener(ServiceListener listener,
                        String filter)
    throws InvalidSyntaxException;

    
    public abstract void addServiceListener(ServiceListener listener);

   
    public abstract void removeServiceListener(ServiceListener listener);

    
    public abstract void addBundleListener(BundleListener listener);

    
    public abstract void removeBundleListener(BundleListener listener);

  
    public abstract void addFrameworkListener(FrameworkListener listener);

    
    public abstract void removeFrameworkListener(FrameworkListener listener);

    
    public abstract ServiceRegistration registerService(String[] clazzes,
                            Object service,
                            Dictionary properties);

    
    public abstract ServiceRegistration registerService(String clazz,
                            Object service,
                            Dictionary properties);

    
    public abstract ServiceReference[] getServiceReferences(String clazz,
                                String filter)
    throws InvalidSyntaxException;

   
    public abstract ServiceReference getServiceReference(String clazz);

   
    public abstract Object getService(ServiceReference reference);

    
    public abstract boolean ungetService(ServiceReference reference);

    
    public abstract File getDataFile(String filename);

   
    public abstract Filter createFilter(String filter)
    throws InvalidSyntaxException;
    /**
     * 获取插件安装环境下的上下文 android.content.Context
     * [已遗弃]新版可用getAndroidContext()替代
     * @return
     */
    public abstract Context getBundleContext();
    /**
     * 获取插件安装环境下的上下文 android.content.Context
     * 替代旧版getBundleContext 的功能
     * @return
     */
    public abstract Context getAndroidContext();
}


